from abc import ABC, abstractmethod

class Serializer(ABC):
    '''
    Interface for custom serializers. Note that normally a Serializer
    must be matched with a Deserializer.
    '''
    @abstractmethod
    def serialize(self, obj:object)-> object:
        '''
        @param obj the python object to be serialized
        @return a json object eg a dict, list or literal, representing the object.
        '''